Index: chan_sip.c
===================================================================
--- chan_sip.c	(revision 41764)
+++ chan_sip.c	(working copy)
@@ -9047,7 +9047,8 @@
 }
 
 /*! \brief  Report Peer status in character string
- * 	\return 1 if peer is online, -1 if unmonitored */
+ *  \return 0 if peer is unreachable, 1 if peer is online, -1 if unmonitored
+ */
 static int peer_status(struct sip_peer *peer, char *status, int statuslen)
 {
 	int res = 0;
@@ -9165,8 +9166,10 @@
 
 	char name[256];
 	int total_peers = 0;
-	int peers_online = 0;
-	int peers_offline = 0;
+	int peers_mon_online = 0;
+	int peers_mon_offline = 0;
+	int peers_unmon_offline = 0;
+	int peers_unmon_online = 0;
 	char *id;
 	char idtext[256] = "";
 	int realtimepeers;
@@ -9185,8 +9188,9 @@
 			if (regcomp(&regexbuf, argv[4], REG_EXTENDED | REG_NOSUB))
 				return RESULT_SHOWUSAGE;
 			havepattern = TRUE;
-		} else
+		} else {
 			return RESULT_SHOWUSAGE;
+		}
 	case 3:
 		break;
 	default:
@@ -9211,25 +9215,23 @@
 
 		if (!ast_strlen_zero(iterator->username) && !s)
 			snprintf(name, sizeof(name), "%s/%s", iterator->name, iterator->username);
-		else
+		else {
 			ast_copy_string(name, iterator->name, sizeof(name));
-
+		}
+		
 		pstatus = peer_status(iterator, status, sizeof(status));
-		if (pstatus) 	
-			peers_online++;
-		else	{
-			if (pstatus == 0)
-				peers_offline++;
-			else {	/* Unmonitored */
-				/* Checking if port is 0 */
-				if ( ntohs(iterator->addr.sin_port) == 0 ) {
-					peers_offline++;
-				} else {
-					peers_online++;
-				}
+		if (pstatus == 1)
+			peers_mon_online++;
+		else if (pstatus == 0)
+			peers_mon_offline++;
+		else {
+			if (iterator->addr.sin_port == 0)
+				peers_unmon_offline++;
+			else {
+				peers_unmon_online++;
 			}
-		}			
-		
+		}
+
 		snprintf(srch, sizeof(srch), FORMAT, name,
 			iterator->addr.sin_addr.s_addr ? ast_inet_ntoa(iterator->addr.sin_addr) : "(Unspecified)",
 			ast_test_flag(&iterator->flags[1], SIP_PAGE2_DYNAMIC) ? " D " : "   ", 	/* Dynamic or not? */
@@ -9278,9 +9280,10 @@
 
 		total_peers++;
 	} while(0) );
-
+	
 	if (!s) {
-		ast_cli(fd,"%d sip peers [%d online , %d offline]\n",total_peers,peers_online,peers_offline);
+		ast_cli(fd, "sip peers %d\nMonitored %d online %d offline\nUnmonitored %d online %d offline\n",
+		        total_peers, peers_mon_online, peers_mon_offline,peers_unmon_online, peers_mon_offline);
 	}
 
 	if (havepattern)
